/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg.linkedhashmapstreamapiapproach;

import java.util.LinkedHashMap;
import java.util.Optional;
import java.util.Map;
/**
 *
 * @author omozegieaziegbe
 */
public class LinkedHashMapStreamApiApproach {

    public static int findKeyPosition(LinkedHashMap<String, Integer> map, String key) {
        int position = 0;
        Optional<String> foundKey = map.entrySet().stream()
                .filter(entry -> entry.getKey().equals(key))
                .map(Map.Entry::getKey)
                .findFirst();

        if (foundKey.isPresent()) {
            // Key found, iterate again to count position
            for (Map.Entry<String, Integer> entry : map.entrySet()) {
                if (entry.getKey().equals(key)) {
                    return position;
                }
                position++;
            }
        }
        return -1; // Key not found
    }

    public static void main(String[] args) {
        
        LinkedHashMap<String, Integer> map = new LinkedHashMap<>();
        map.put("apple", 10);
        map.put("banana", 20);
        map.put("cherry", 30);

        int position = findKeyPosition(map, "banana");

        if (position != -1) {
            System.out.println("Key 'banana' found at position: " + position);
        } else {
            System.out.println("Key 'banana' not found");
        }
    }
}